Attribute VB_Name = "ModMemory"
Option Explicit

'Modulo per le funzioni all'accesso della memoria

Type INT64
    LoPart As Long
    HiPart As Long
End Type

Type MEMORYSTATUSEX
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As INT64
    dwAvailPhys As INT64
    dwTotalPageFile As INT64
    dwAvailPageFile As INT64
    dwTotalVirtual As INT64
    dwAvailVirtual As INT64
    UlAvailExtendedVirtual As INT64
End Type

Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Type MEMORY_STAT
    dwTotalPhys As Double
    dwAvailPhys As Double
    dwUsedPhys As Double
    dwTotalPageFile As Double
    dwAvailPageFile As Double
    dwUsedPageFile As Double
    dwTotalVirtual As Double
    dwAvailVirtual As Double
    dwUsedVirtual As Double
    UlAvailExtendedVirtual As Double
End Type

Public GetMemoryStatusOld As Long
Declare Function GlobalMemoryStatusEx Lib "kernel32" (lpBuffer As MEMORYSTATUSEX) As Long
Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)

'funzioni utilizzo CPU

Type CPU_STAT
   usr As Double
   kernel As Double
   idle As Double
   system As Double
   cpu As Double
End Type

Declare Function GetSystemTimes Lib "kernel32" (lpIdleTime As INT64, lpKernelTime As INT64, lpUserTime As INT64) As Long
Private idleTime As Double, kernelTime As Double, userTime As Double

' funzioni di accesso al disco
Type DISK_PERFORMANCE
  BytesRead As INT64
  BytesWritten As INT64
  ReadTime As INT64
  WriteTime As INT64
  ReadCount As Long
  WriteCount As Long
  QueueDepth As Long
End Type

Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
'Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, lpOverlapped As OVERLAPPED) As Long
Const IOCTL_DISK_PERFORMANCE = &H70020
Const IOCTL_DISK_BASE = &H7&

Function GetCPUTimes(cpuStat As CPU_STAT) As Integer
Dim idleTime1 As INT64, kernelTime1 As INT64, userTime1 As INT64
Dim idleTimeD As Double, kernelTimeD As Double, userTimeD As Double
  
  GetSystemTimes idleTime1, kernelTime1, userTime1
  idleTimeD = Int642Double(idleTime1)
  kernelTimeD = Int642Double(kernelTime1)
  userTimeD = Int642Double(userTime1)
  
  cpuStat.usr = userTimeD - userTime
  cpuStat.kernel = kernelTimeD - kernelTime
  cpuStat.idle = idleTimeD - idleTime

  cpuStat.system = cpuStat.kernel + cpuStat.usr
  cpuStat.cpu = (cpuStat.system - cpuStat.idle) * 100 / cpuStat.system
  
  userTime = userTimeD
  kernelTime = kernelTimeD
  idleTime = idleTimeD
  
End Function

Function GetMemoryStatus(MemStat As MEMORY_STAT) As Integer
Dim pUdtMemStatus As MEMORYSTATUS
Dim pUdtMemStatusEx As MEMORYSTATUSEX

  'On Error Resume goto
  If GetMemoryStatusOld = 1 Then
    pUdtMemStatus.dwLength = Len(pUdtMemStatus)
    GlobalMemoryStatus pUdtMemStatus
    
    With MemStat
    .dwTotalPhys = pUdtMemStatus.dwTotalPhys
    .dwAvailPhys = pUdtMemStatus.dwAvailPhys
    .dwUsedPhys = .dwTotalPhys - .dwAvailPhys
    .dwTotalPageFile = pUdtMemStatus.dwTotalPageFile
    .dwAvailPageFile = pUdtMemStatus.dwAvailPageFile
    .dwTotalVirtual = pUdtMemStatus.dwTotalVirtual
    .dwAvailVirtual = pUdtMemStatus.dwAvailVirtual
    .dwUsedPhys = .dwTotalPhys - .dwAvailPhys
    .dwUsedPageFile = .dwTotalPageFile - .dwAvailPageFile
    .dwUsedVirtual = .dwTotalVirtual - .dwAvailVirtual
    End With
  Else
    pUdtMemStatusEx.dwLength = Len(pUdtMemStatusEx)
    If GlobalMemoryStatusEx(pUdtMemStatusEx) = 0 Then
      GetMemoryStatusOld = 1
    Else
      With MemStat
      'pUdtMemStatusEx.dwTotalPhys.HiPart = 1
      .dwTotalPhys = Int642Double(pUdtMemStatusEx.dwTotalPhys) / 1024 / 1024
      .dwAvailPhys = Int642Double(pUdtMemStatusEx.dwAvailPhys) / 1024 / 1024
      .dwTotalPageFile = Int642Double(pUdtMemStatusEx.dwTotalPageFile) / 1024 / 1024
      .dwAvailPageFile = Int642Double(pUdtMemStatusEx.dwAvailPageFile) / 1024 / 1024
      .dwTotalVirtual = Int642Double(pUdtMemStatusEx.dwTotalVirtual) / 1024 / 1024
      .dwAvailVirtual = Int642Double(pUdtMemStatusEx.dwAvailVirtual) / 1024 / 1024
      .dwUsedPhys = .dwTotalPhys - .dwAvailPhys
      .dwUsedPageFile = .dwTotalPageFile - .dwAvailPageFile
      .dwUsedVirtual = .dwTotalVirtual - .dwAvailVirtual
      End With
    End If
  End If
End Function

Private Function Int642Double(V64 As INT64) As Double
Const d32 As Double = 2# ^ 32

  Int642Double = IIf(V64.LoPart < 0, d32 + V64.LoPart, V64.LoPart) + (V64.HiPart * d32)
End Function

